'use strict';

require('path');
require('hable');
require('signal-exit');
require('os');
require('child_process');
require('tree-kill');
require('./tib-browserstack-local.js');
require('vue-template-compiler');
require('crypto');
require('fs');
require('util');
require('glob');
require('webpack');
require('@babel/core');
require('@babel/parser');
require('./tib-browser.js');
require('http');
require('./tib-webpage.js');
const index = require('./tib-index.js');

class IESeleniumBrowser extends index.default {
  constructor(config) {
    super(config);

    this.setBrowser('ie');

    /* istanbul ignore next */
    this.hook('selenium:build:before', async (builder) => {
      // TODO
      const configArguments = [];

      const options = new IESeleniumBrowser.Options();
      options.addArguments(...configArguments);

      await this.callHook('selenium:build:options', options, builder);

      builder.setIEOptions(options);
    });
  }

  /* istanbul ignore next */
  async _loadDependencies() {
    super._loadDependencies();

    if (!IESeleniumBrowser.driverLoaded) {
      if (await this.loadDependency('iedriver')) {
        IESeleniumBrowser.driverLoaded = true;
      }
    }

    if (!IESeleniumBrowser.Options) {
      const { Options } = await this.loadDependency('selenium-webdriver/ie');
      IESeleniumBrowser.Options = Options;
    }
  }
}

exports.default = IESeleniumBrowser;
