'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('path');
require('hable');
require('signal-exit');
require('os');
require('child_process');
require('tree-kill');
const browserstackLocal = require('./tib-browserstack-local.js');
require('vue-template-compiler');
require('crypto');
require('fs');
require('util');
require('glob');
require('webpack');
require('@babel/core');
require('@babel/parser');
const browser$1 = require('./tib-browser.js');
require('http');

async function createBrowser(str, conf, autoStart = true) {
  const instance = browser$1.Browser.get(str, conf);
  if (!autoStart) {
    return instance
  }

  return (await instance).start()
}

function browser(...args) {
  /* istanbul ignore next */
  console.warn('DeprecationWarning: \'browser\' has been renamed to \'createBrowser\''); // eslint-disable-line no-console
  /* istanbul ignore next */
  return createBrowser(...args)
}

exports.createPageFunctions = browserstackLocal.createPageFunctions;
exports.commands = browser$1.index;
exports.browser = browser;
exports.createBrowser = createBrowser;
